extends Node

# we want to use this to convert the mana cost into text 
# in the helper text box, but thats for the future
const ManaCosts = preload("res://data/mana.gd")

var cached = false

var card_id = "placedholder_id"
var card_name = "placeholder_name"
var card_type = "placeholder_card_type"
var oracle_text = "placeholder_oracle_text"

func _check_cache() -> bool:
	## want to check the cache before we make any scryfall calls
	return false

func _do_scryfall_get(id) -> void:
	# TODO: fetch the card here...

	var fetched = false

	if !fetched:
		print("Failed to fetch card data from scryfall")

	var card_content = "fetched_card_json" #TODO
	var card_cache = FileAccess.open("user://card_cache/" + id + ".json", FileAccess.WRITE)
	card_cache.store_string(card_content)
	card_cache = null # closes the file

	
func load_card(id) -> void:
	if !(_check_cache()):
		_do_scryfall_get(id)
	
	var ondisk_card = FileAccess.open("user://card_cache/" + id + ".json", FileAccess.READ)
	# parse json here to get card content
	card_id = id
	card_name = "loaded_cardname"
	card_type = "loaded_type"
	oracle_text = "loaded_oracletext"

	ondisk_card = null
	pass

## these variables above will be used for the helper boxes we draw
## on hover, to make cards easier to read
